/*
 * Copyright (c) 2015. Ncomz. All Rights Reserved
 */

package com.ntels.kneet.v3.view.things;

import android.app.Activity;
import android.content.Intent;
import android.content.res.Configuration;
import android.os.Bundle;
import android.os.Handler;
import android.os.Message;
import android.support.v7.widget.Toolbar;
import android.view.LayoutInflater;
import android.view.View;
import android.widget.Toast;

import com.ntels.kneet.v3.common.AppConfig;
import com.ntels.kneet.v3.common.Constants;
import com.ntels.kneet.v3.common.http.HttpSend;
import com.ntels.kneet.v3.common.http.Response;
import com.ntels.kneet.v3.common.c_interface.Main_Interface;
import com.ntels.kneet.v3.common.c_interface.OnDataSendToReslut;
import com.ntels.kneet.v3.common.util.Dlog;
import com.ntels.kneet.v3.common.util.Util;
import com.ntels.kneet.v3.common.widget.CustomActivity;
import com.ntels.kneet.v3.R;
import com.ntels.kneet.v3.view.dialog.CustomDialog;

import org.json.JSONObject;

import java.util.ArrayList;
import java.util.HashMap;

public class Things_Homehub_Guide_04_02 extends CustomActivity implements View.OnClickListener,
                                                                          CustomDialog.OnMsgAlterToResult {

    /*툴바 관련*/
    private Toolbar toolbar;

    /*통신 관련*/
    private              ArrayList<HashMap<String, Object>> alTotalList                                = new ArrayList<HashMap<String, Object>>();
    private              int                                iType                                      = 0;
    private static final int                                MSG_COM_P_DEVICES_PARTNER_DEVICE_OWNERSHIP = 1;

    /*공통*/
    private Activity       act;
    private AppConfig      appConfig;
    private Main_Interface mCallback;
    private Intent         intent;
    private Util         util                      = new Util();
    private CustomDialog customDialog              = new CustomDialog();
    private String       sCallType                 = "";
    private String       sHTTP_activation_code     = "";
    private String       sHTTP_activation_password = "";
    private String       sPass                     = "";

    /**
     * <PRE>
     * 1. MethodName: onCreate
     * 2. ClassName :
     * 3. Comment   : onCreate
     * 4. Developer : 최진오
     * 5. Created   : 2015. 10.
     * </PRE>
     */
    @Override public void onCreate(Bundle savedInstanceState) {

        super.onCreate(savedInstanceState);

        act = Things_Homehub_Guide_04_02.this;
        appConfig = (AppConfig) act.getApplicationContext();
        customDialog.setOnMsgAlterToResultEvent(this);

        View viewToLoad = LayoutInflater.from(act).inflate(R.layout.things_homehub_guide_04_02, null);
        this.setContentView(viewToLoad);

        if ( savedInstanceState != null ) {
            // sTitle =
            // savedInstanceState.getString(Constants.EXTRA_SPINNER_TITLE);
            // aList1 =
            // savedInstanceState.getStringArrayList(Constants.EXTRA_SPINNER_LIST1);
            // aList2 =
            // savedInstanceState.getStringArrayList(Constants.EXTRA_SPINNER_LIST2);
            // // 0: 세로 한개 선택, 1: 가로 한개선택
            // iType = savedInstanceState.getInt(Constants.EXTRA_SPINNER_TYPE,
            // 0);
            // sBtn1 =
            // savedInstanceState.getString(Constants.EXTRA_SPINNER_BTN1);
            // sBtn2 =
            // savedInstanceState.getString(Constants.EXTRA_SPINNER_BTN2);
            // iPosition =
            // savedInstanceState.getInt(Constants.EXTRA_SPINNER_POSITION, 0);
        } else {
            Intent intent = getIntent();
            sHTTP_activation_code = intent.getStringExtra(Constants.EXTRA_ACTIVATION_CODE);
            sHTTP_activation_password = intent.getStringExtra(Constants.EXTRA_PASSWORD);
            sCallType = intent.getStringExtra(Constants.EXTRA_CALL_TYPE);
        }

        util.getView(act, R.id.llBtn1).setOnClickListener(this);
        util.getView(act, R.id.btnExit).setOnClickListener(this);

        setDisp();
    }

    private void setDisp() {

        util.getView(act, R.id.tvNum).setVisibility(View.VISIBLE);
        //        util.getTextView(act, R.id.edtName).setText(appConfig.getNickname());
    }

    @Override public void onConfigurationChanged(Configuration newConfig) {

        super.onConfigurationChanged(newConfig);
    }

    @Override public void onClick(View v) {

        switch (v.getId()) {
            case R.id.llBtn1:
                sPass = util.getEditTextVal(act, R.id.edtPass);
                if ( sPass.equals("") ) {
                    util.setShowToast(act, util.getString(act, R.string.layout_things_guide_16) + util.getString(act, R.string.MSG901), Toast.LENGTH_SHORT);
                    return;
                }

                ComHandler.sendMessageDelayed(ComHandler.obtainMessage(MSG_COM_P_DEVICES_PARTNER_DEVICE_OWNERSHIP), 10);
                break;
            case R.id.btnExit:
                onBackPressed();
                break;
            default:
                break;
        }
    }

    Handler ComHandler = new Handler(new IncomingHandlerCallBack());

    class IncomingHandlerCallBack implements Handler.Callback {

        @Override public boolean handleMessage(Message msg) {

            iType = msg.what;
            switch (msg.what) {
                case MSG_COM_P_DEVICES_PARTNER_DEVICE_OWNERSHIP:
                    send_P_devices_partner_device_ownership();
                    break;

                default:
                    break;
            }
            return true;
        }
    }

    private void send_P_devices_partner_device_ownership() {

        try {
            HttpSend httpSend;
            httpSend = new HttpSend(act);
            httpSend.setOnDataSendToReslutEvent(new OnDataSendToReslut() {
                @Override public void resultResponse(Response result) {

                    result_P_devices_partner_device_ownership(result);
                }
            });

//            httpSend.P_devices_partner_device_ownership(sHTTP_activation_code, sHTTP_activation_password, sPass);
        } catch (Exception ex) {
            ex.printStackTrace();
        }
    }

    private void result_P_devices_partner_device_ownership(Response rpResult) {

        try {
            if ( rpResult.getStatusCode() == 200 ) {
                JSONObject joResult = new JSONObject(rpResult.getContent());
                Dlog.v(joResult.toString());

                String sHTTP_device_id = util.null2string(joResult.get(Constants.HTTP_device_id));

                appConfig.setSelect_Homegrp_Homehub_Device_Id(sHTTP_device_id);
                intent = new Intent();
                act.setResult(RESULT_OK, intent);
                finish();
            } else {
                JSONObject joResult = new JSONObject(rpResult.getContent());
                Dlog.v(joResult.toString());
                String sERR_CODE = util.null2string(joResult.get(Constants.HTTP_err_code));
                String sERR_MSG = util.null2string(joResult.get(Constants.HTTP_err_msg));

                if ( sERR_CODE.equals("401") ) {
                    customDialog.MsgAlert(act, Constants.MSG998, sERR_MSG);
                } else if ( sERR_CODE.equals("401-106") ) {
                    customDialog.MsgAlert(act, Constants.MSG997, sERR_MSG);
                } else {
                    util.setShowToast(act, sERR_MSG, Toast.LENGTH_SHORT);
                }
            }
        } catch (Exception ex) {
            ex.printStackTrace();
            customDialog.MsgAlert(act, Constants.MSG807);
        }
    }

    /**
     * <PRE>
     * 1. MethodName: onBackPressed
     * 2. ClassName :
     * 3. Comment   : 뒤로가기 버튼
     * 4. Developer : 최진오
     * 5. Created   : 2015. 10.
     * </PRE>
     */
    @Override public void onBackPressed() {

        intent = new Intent();
        act.setResult(RESULT_CANCELED, intent);
        finish();
        return;
    }

    /**
     * <PRE>
     * 1. MethodName: onResume
     * 2. ClassName :
     * 3. Comment   : onResume
     * 4. Developer : 최진오
     * 5. Created   : 2015. 10.
     * </PRE>
     */
    @Override public void onResume() {

        super.onResume();

        // if (!GreenBilllab.getIntro()) {
        // if (Main.reLoginCheck()) {
        // onBackPressed();
        // }
        // }
    }

    @Override public void resultCustomDialogResponse(int iMsgID, int iBtnResult) {

        switch (iMsgID) {

            case Constants.MSG998:
                util.callApp_Start(act, "LOGOUT");
                break;
            case Constants.MSG997:
                util.callApp_Start(act, "HOME_RELOAD");
                break;
            case Constants.MSG807:
                if ( iBtnResult == 1 ) {
                    ComHandler.sendMessageDelayed(ComHandler.obtainMessage(iType), 10);
                }
                break;
            case Constants.MSG833:
                if ( iBtnResult == 1 ) {
                    onBackPressed();
                }
                break;
            default:
                break;
        }
    }

    @Override public void onActivityResult(int requestCode, int resultCode, Intent data) {

        super.onActivityResult(requestCode, resultCode, data);

        if ( resultCode == act.RESULT_OK ) {
            switch (requestCode) {
                //                case Constants.ACT_SETTING:
                //                    break;
            }
        } else {
            switch (requestCode) {
                //                case Constants.ACT_THINGS_GROUP_EDIT:
                //                    bReload_Flag = data.getBooleanExtra(Constants.EXTRA_RELOAD_FLAG, false);
                //                    if ( bReload_Flag ) {
                //                        ComHandler.sendMessageDelayed(ComHandler.obtainMessage(MSG_COM_GROUPS_DEVICES), 10);
                //                    }
                //                    break;
            }
            // if (appConfig.getGoErr()) {
            // act.setResult(act.RESULT_CANCELED, new Intent());
            // finish();
            // }
        }
    }
}
